-- Made by @aquamonkey
-- TRACKMANIA but in kart
local roundTime = 0
local endTime = 0
local raceActive = false
local spawnPointx = nil
local spawnPointy = nil
local spawnPointz = nil
local spawnPointangle = nil
local worstScore = 999999
local bestLaps = {}
local savedTimes = {}
local allTimes = {}
local sprintMap = false
local fallingStart = false

local starttime = (6*TICRATE + (3*TICRATE/4))
local introtime = (3*TICRATE + (3*TICRATE/4))
local nojointime = 20*TICRATE
local roundendwarnTime = 60*TICRATE
local warnTime = 0	-- counter for how long to display the round end warning
local exitTime = 0 	-- counter keeping track of how long we've been exiting
local showScoreboard = false
local announcementTime = 0
local announcementGraphic  -- announce new records
local announcementMessage = {}
local scoreboardTimer = 0	-- DO NOT NETVAR

local boostAnimNum = 1
local colInterval = 0
local infColor = 0

freeslot("sfx_lapsta", "sfx_lapch")

-- commands
local akmRoundTime = CV_RegisterVar({		-- forces hell cups when set to on
	name = "akm_roundtime",
	defaultvalue = 360,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 0, MAX = 999999999},
})

local akmCpCooldown = CV_RegisterVar({			-- print cup picks to the console
	name = "akm_cpcooldown",
	defaultvalue = 3,
	flags = NULL,
	PossibleValue = {MIN = 0, MAX = 600},
})

local akmHideLB = CV_RegisterVar({
	name = "akm_hidelb",
	defaultvalue = 0,
	flags = NULL,
	PossibleValue = {MIN = 0, MAX = 30},
})

--force sneker
local akmForceSneker = CV_RegisterVar({
	name = "akm_forcesneaker",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
})

local akmPrintCPs = CV_RegisterVar({
	name = "akm_printcheckpoints",
	defaultvalue = "Off",
	flags = NULL,
	PossibleValue = CV_OnOff,
})

local akmPrintRecords = CV_RegisterVar({
	name = "akm_printrecords",
	defaultvalue = "Off",
	flags = NULL,
	PossibleValue = CV_OnOff,
})

local akmDebug = CV_RegisterVar({
	name = "akm_debug",
	defaultvalue = "Off",
	flags = CV_NOSHOWHELP,
	PossibleValue = CV_OnOff,
})

local function endRace(player)
	if player ~= server and not IsPlayerAdmin(player) then
		CONS_Printf(player, "Vote for this command instead of calling it.")
		return "banned"
	end
	
	roundTime = 0
end
COM_AddCommand("akm_endrace", endRace)

-- allow players to join the race after the initial 20 seconds passed
-- copied from Aqua's Grand Prix
local function akmPlayerJoin(player)
	if leveltime <= starttime or (raceActive and player.spectator == true) then
		player.spectator = false
		player.pflags = PF_WANTSTOJOIN
		player.kartstuff[k_spectatewait] = 0
		player.playerstate = PST_REBORN
		player.waitToJoin = 1
		chatprint("\130*"..player.name.." late-joined the game.")
	elseif not player.spectator
		CONS_Printf(player, "[KM] You're already playing. Vroom vroom")
	end
end
COM_AddCommand("akm_join", akmPlayerJoin)

// from HOSTMOD (i think)
local buildTimeString = function(x)
	if x == nil or x == 99999999 then return nil end
	return {string.sub(string.format("%02d", G_TicsToMinutes(x)), 1, 1), string.sub(string.format("%02d", G_TicsToMinutes(x)), 2, 2), string.sub(string.format("%02d", G_TicsToSeconds(x)), 1, 1), string.sub(string.format("%02d", G_TicsToSeconds(x)), 2, 2), string.sub(string.format("%02d", G_TicsToCentiseconds(x)), 1, 1), string.sub(string.format("%02d", G_TicsToCentiseconds(x)), 2, 2)}
end

// convert tics to a human readable string
// probably also from HOSTMOD. been too long
local function ticToTime(x)
	// format string
	local string = (string.format("%02d", G_TicsToMinutes(x)) + ":" + string.format("%02d", G_TicsToSeconds(x)) + "." +  string.format("%02d", G_TicsToCentiseconds(x)))
	return string
end

-- build the full name of the map
local function buildMapTitle(gamemap)
	local mapName = mapheaderinfo[gamemap].lvlttl
	if #mapheaderinfo[gamemap].zonttl ~= 0 then mapName = $.." "..mapheaderinfo[gamemap].zonttl end
	return mapName
end


local function readMapTimes()
	local mapTimes = io.open("kartmania_times.txt", "r")
	
	if not (mapTimes) then
		if akmDebug.value then print("[AKM] No previous records exist, not showing medals") end
		return "idiot"
	end
	
	for line in mapTimes:lines()
		local mapNum, _, pos, _, time, _, name = string.match(line, "(%d+)(;)(%d)(;)(%d+)(;)(.+)") -- probably not efficient, but do i look like i care
		--print(pos, time.." ("..ticToTime(time)..")", name)
		if akmDebug.value then print("[AKM] RECORD: "..mapNum.."; "..pos..". "..time.." by "..name) end
		table.insert(allTimes, {mapNum, pos, time, name})
	end

	print("[AKM] Loaded "..#allTimes.." stored map times succesfully")
	
end

local function writeMapTimes()
	print("[AKM] Writing map times to disk for map "..gamemap)
	-- do you guys remember when diggle said 'its writing time' and then he wrote all over the place
	local mapTimes = io.open("kartmania_times.txt", "w")
	
	// extremely dumb way to replace records
	// first just fuckin remove all current records
	if akmDebug.value then print("[AKM] Replacing old records for current map") end
	local i = 1
	while i <= #allTimes
		if tonumber(allTimes[i][1]) == gamemap then
			if akmDebug.value then print("[AKM] Matched record "..i.." for current map, removing it") end
			table.remove(allTimes, i)
		else
			i = $ + 1
		end
	end
	
	// now add the new ones
	if akmDebug.value then print("[AKM] Length of saved times: "..#savedTimes) end
	if #savedTimes >= 1 then 
		if akmDebug.value then print("[AKM] Inserting #1 record into all times table") end
		table.insert(allTimes, {gamemap, savedTimes[1][1],savedTimes[1][2],savedTimes[1][3]}) 
	end
	if #savedTimes >= 2 then 
		if akmDebug.value then print("[AKM] Inserting #2 record into all times table") end
		table.insert(allTimes, {gamemap, savedTimes[2][1],savedTimes[2][2],savedTimes[2][3]}) 
	end
	if #savedTimes >= 3 then 
		if akmDebug.value then print("[AKM] Inserting #3 record into all times table") end
		table.insert(allTimes, {gamemap, savedTimes[3][1],savedTimes[3][2],savedTimes[3][3]}) 
	end
	
	if consoleplayer == server then 
		-- when writing this print statement i realised why record shit was being desynced
		if akmDebug.value then print("[AKM] Writing all records to disk") end
		for k, v in pairs(allTimes)
			mapTimes:write(v[1]..';'..v[2]..';'..v[3]..';'..v[4], '\n')
		end
	end
end

local function calculateRoundData()
	if akmDebug.value then print("[AKM] Calculating round data") end

	// are we on a sprinter map?
	if mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE then sprintMap = true
	else sprintMap = false end
	
	// check if there's saved times
	for k, v in pairs(allTimes) do
		if tonumber(v[1]) == gamemap then		// hit a map record
			table.insert(savedTimes, {v[2], v[3], v[4]})
		end
	end
	if akmDebug.value then print("[AKM] Added "..#savedTimes.." records to this round") end

	// set round duration
	// if roundtime command ~= 0, adhere to it
	if akmRoundTime.value ~= 0 then roundTime = akmRoundTime.value*TICRATE
	else
		// if on a circuit map, lets use 6 minutes
		if not sprintMap then roundTime = 360*TICRATE
		else	// lets calculate a time for sprint maps
			if akmDebug.value then print("[AKM] On a sprint map, calculating round time") end
			if #savedTimes ~= 0 then	// if we have a saved time to use, allow ppl to try for 4 complete laps
				roundTime = (tonumber(savedTimes[1][2]) * 6)
				if akmDebug.value then print("[AKM] Calculated round time from 1st record: "..roundTime.." ("..ticToTime(roundTime)..")") end
				// lets set a minimum boundary for sprint maps
				if roundTime < 480*TICRATE then 
					if akmDebug.value then
						print("[AKM] Calculated round time is lower than 8 minutes")
						print("[AKM] Forcing 8 min time limit")
					end
					roundTime = 480*TICRATE 
				end
			else	// no saved times, just set a default time
				if akmDebug.value then print("[AKM] No saved time, using default roundtime") end
				roundTime = 480*TICRATE
			end
		end
	end
	if akmDebug.value then print("[AKM] Final round time: "..roundTime*TICRATE.." ("..ticToTime(roundTime)..")") end

	// find spawn point that everyone will use
	// it will be a combination of the player with the lowest score and earliest node
	// cant wait for this to break
	for p in players.iterate
		//CONS_Printf(p, "Finding spawnpoint")
		if not p.spectator and p.score < worstScore
			worstScore = p.score
			// get players spawn point
			spawnPointx = p.mo.x
			spawnPointy = p.mo.y
			spawnPointz = p.mo.z
			
			spawnPointangle = p.mo.angle
			//CONS_Printf(p, "New spawnpoint set")
		end
	end
	
	if akmForceSneker.value then
		if akmDebug.value then print("[AKM] Forcing kartdebugitem and kartdebugamount") end
		COM_BufInsertText(server, "kartdebugitem 1; kartdebugamount 1")
	end
	
	endTime = roundTime
	// reset dis
	exitTime = 0
end

local function spawnPlayer(p)
	if p.valid and not p.spectator then
		p.mo.momx = 0
		p.mo.momy = 0
		p.mo.momz = 0

		P_SetOrigin(p.mo, spawnPointx, spawnPointy, spawnPointz)
		p.mo.angle = spawnPointangle

		if leveltime > 3 and raceActive then
			p.respawnflash = 7
			S_StartSound(nil, sfx_s3kaf, p)
		end
		
		if akmDebug.value then CONS_Printf(p, "[AKM] Reset your run!") end
	end
end

-- flash screen on respawn
hud.add(function(v, p, c)
	if not p.respawnflash then return end
	v.fadeScreen(SKINCOLOR_WHITE, min(10, max(p.respawnflash, 0)))
end)

local function setupPlayer(p)
	-- wow. this probably is really stupid
	-- i mean, have you ever seen such a huge dumbass function just manually setting shit left and right?
	
	// set up playerdata
	if raceActive then 
		if fallingStart then p.countdown = 59
		else p.countdown = 53 end	-- freeze player for a little while after respawn
	else p.countdown = 0 end
	p.finished = false
	p.cpdisplay = 0	-- counter for checkpoint display
	p.respawnflash = 0
	p.resetTimer = 35
	p.resetWidth = 0
	p.distance = 0
	p.laps = 0
	p.klaps = 0
	p.lapTime = 0
	p.CPs = {}
	p.CPi = false
	p.oldstarpostnum = 0
	p.starpostnum = 0
	p.splittime = 0
	p.cpsplit = 0
	K_StripItems(p)
	p.kartstuff[k_respawn] = 0
	p.kartstuff[k_driftboost] = 0
	p.kartstuff[k_sneakertimer] = 0
	p.kartstuff[k_spinouttimer] = 0
	p.kartstuff[k_boostcharge] = 0
	p.kartstuff[k_speedboost] = -FRACUNIT
	if p.mo ~= nil then 
		p.mo.momx = 0
		p.mo.momy = 0
		p.mo.momz = 0
		p.mo.tracer = nil 
	end
	if p.waitToJoin == nil then p.waitToJoin = 0 end
	if p.bestLap == nil then p.bestLap = 0 end
	if p.bestCPs == nil then p.bestCPs = {} end
	p.cpCooldown = 0
	p.finished = false
	p.maniaReady = true
	
	hud.disable("speedometer")
	hud.disable("gametypeinfo")
	hud.disable("position")
	hud.disable("time")
	hud.disable("freeplay")
	hud.disable("minirankings")
	hud.disable("rankings")
end

local function handleRace()
	if leveltime == 0
		if akmDebug.value then print("[AKM] It's racing time baybee") end
		raceActive = false
		bestLaps = {}
		savedTimes = {}
		worstScore = 999999
		COM_BufAddText(server, "allowteamchange off") -- why is this here again
	end
	
	if leveltime == 1 then
		// calculate round time and spawn point
		calculateRoundData()
	end
	
	if leveltime == 2
		// set the spawn point for all players and reset times
		if akmDebug.value then print("[AKM] Setting player data and spawns") end
		for p in players.iterate
			setupPlayer(p)
			spawnPlayer(p)
			
			p.bestLap = 0
			p.bestCPs = {}
			p.countdown = 0
		end
	end

	if leveltime == 10
		for p in players.iterate			
			if akmDebug.value then print("[AKM] Checking if player is falling...") end
			if p.valid and p.spectator then continue end	// dont care about spectators
			if p.mo.momz/FRACUNIT ~= 0 then
				if akmDebug.value then print("[AKM] Player moving on spawn, activating countdown wait") end
				fallingStart = true
			else 
				if akmDebug.value then print("[AKM] Player not falling on spawn") end
				fallingStart = false 
			end
		end
	end
	
	// race START
	if leveltime == (6*TICRATE + (3*TICRATE/4))
		raceActive = true
		for p in players.iterate
			if p.valid and not p.spectator then 
			p.countdown = 0
			if p.cmd.buttons & BT_ACCELERATE then p.kartstuff[k_boostcharge] = 35 end
			end
		end
		COM_BufAddText(server, "allowteamchange on")
		
	end
	
	if leveltime == (6*TICRATE + (3*TICRATE/4)) + 1
		for p in players.iterate
			if p.valid and not p.spectator and S_SoundPlaying(p.mo, sfx_s25f) then
				S_StopSound(p.mo)
				
				--S_StartSoundAtVolume(p.mo, sfx_s25f, 255/#players, p)
				-- the game plays the sound and is still stopping all sounds at that point
				-- i just do not care
			end
		end
	end
	
	if raceActive
		if roundTime ~= 0
			// keep racing
			for p in players.iterate
				if p.valid and p.spectator then continue end	// start playing fool

				if not p.finished and p.countdown == 0 then p.lapTime = p.lapTime + 1 end

				// distance calculation, probably very incorrect
				if p.valid and not p.spectator and p.countdown == 0 and p.kartstuff[k_respawn] == 0 then
					if p.oldX == nil then p.oldX = p.mo.x end
					if p.oldY == nil then p.oldY = p.mo.y end
					local diffx = p.oldX/FRACUNIT - p.mo.x/FRACUNIT
					local diffy = p.oldY/FRACUNIT - p.mo.y/FRACUNIT
					
					if diffx < 0 then p.distance = $ + -diffx
					else p.distance = $ + diffx end
					if diffy < 0 then p.distance = $ + -diffy
					else p.distance = $ + diffy end
					
					p.oldX = p.mo.x
					p.oldY = p.mo.y
				elseif p.valid and not p.spectator -- always update old shit
					p.oldX = p.mo.x
					p.oldY = p.mo.y
				end
				// i was never good at math after all
				
				// track checkpoints
				if p.oldstarpostnum ~= p.starpostnum and not p.finished then
					p.CPs[p.starpostnum] = p.lapTime
					--table.insert(p.CPs, p.lapTime)
					p.oldstarpostnum = p.starpostnum
					
					// show CP display
					if (akmCpCooldown.value ~= 0 and p.cpCooldown == 0) or akmCpCooldown.value == 0 then
						p.splittime = p.lapTime
						if p.bestCPs ~= nil and #p.bestCPs ~= 0 then
							local diff = p.bestCPs[p.starpostnum] - p.lapTime
							p.CPi = true
							if diff < 0 then 
								diff = -diff 
								p.CPi = false
							end
							p.cpsplit = diff
						end
						
						S_StartSound(nil, sfx_lapch, p)
						p.cpdisplay = 70
						p.cpCooldown = akmCpCooldown.value*TICRATE
					end
				end
				
				if p.cpdisplay ~= 0 then p.cpdisplay = $ - 1 end
				if p.cpCooldown ~= 0 then p.cpCooldown = $ - 1 end
			end
			
			// round end warn timer
			if roundTime == roundendwarnTime then
				warnTime = 4*TICRATE
				S_StartSound(nil, sfx_s3k68, displayplayers[0])
			end
			if warnTime ~= 0 then warnTime = $ - 1 end
			
			// last 10 seconds beeps
			if roundTime <= 350 and roundTime % 35  == 0 then
				S_StartSound(nil, sfx_kc39, displayplayers[0])
			end

			roundTime = roundTime - 1
			rawset(_G, "akm_roundtime", roundTime)
		else
			// end the race
			raceActive = false
			S_StartSound(nil, sfx_s3k6a, displayplayers[0])
			for p in players.iterate
				p.exiting = 1 -- decrements automatically
			end
		end
	elseif leveltime > starttime and roundTime == 0 and raceActive == false then
		exitTime = $ + 1
		
		if #bestLaps ~= 0 then
			if exitTime == 1 then
				local worstTime = bestLaps[#bestLaps].bestLap * 2
				for p in players.iterate
					if p.bestLap >= 1 then p.realtime = p.bestLap	// if players drove a best lap, assign them their best lap as finish time.	
					else p.realtime = worstTime end					// otherwise make them the worst time times 2 so they dont score points :)
				end
			end
			
			if exitTime == 2 then
				-- lets save scores (but only servers)
				writeMapTimes()
			end
		elseif exitTime == 1 then
			print("[AKM] No times recorded, not writing to disk")
		end
		
		if exitTime == 5*TICRATE then
			if akmDebug.value then print("[AKM] Setting player finish state") end
			-- exit the round
			for p in players.iterate
				p.exiting = 8
			end
		end
	end
	
	if announcementTime ~= 0 then
		announcementTime = $ - 1
	end
end

local function resetPlayer(p)
	// funni grindrails
	if p.grinding then p.grinding = false end
	
	// first reset player vars
	setupPlayer(p)
	
	// then teleport the player back to spawn
	spawnPlayer(p)
end

local function setAnnouncement(graphic, msg1, msg2, time)
	-- this function sets a graphic and message to display, which will show up next to the item box
	announcementGraphic = graphic
	announcementMessage[1] = msg1
	announcementMessage[2] = msg2
	announcementTime = time
end

-- disable player collision
local function playerColRet(thing, tmthing)
	if tmthing.type == MT_PLAYER and thing.type == MT_PLAYER return false end
end

-- inserts the specified player into the best lap table and sorts it
-- wow, look at this huge function. imagine if i just inserted records into the table and then cut the table to a top 3. that would be so much easier instead of manually tracking this shit. it really would huh
local function insertBestLap(p)
	for index, bP in pairs(bestLaps)
		if #bP == #p then
			--print("found "..#p.." "..p.name.." in best laps")
			table.remove(bestLaps, index)
		end
	end
	
	-- insert the player's lap time into the table
	table.insert(bestLaps, p)
	
	-- now sort the table based on laptime
	table.sort(bestLaps, function(a, b)
		return a.bestLap < b.bestLap
	end)
	
	-- check if we have a new top saved time
	local timeSet = false
	
	-- do you guys remember when juggy said 'its sorting time' and then he sorted all over the place
	if #savedTimes == 0 then 	-- new record baybee
		if akmPrintRecords.value then print("[AKM] "..p.name.." set a new #1 record!") end
		setAnnouncement("GOTITA", p.name.." just set a", "1st place record!", 8*TICRATE)
		S_StartSound(nil, sfx_cdpcm2, displayplayers[0])
		savedTimes[1] = {1, p.bestLap, p.name, p}
	elseif #savedTimes == 1 then
		if p.bestLap < tonumber(savedTimes[1][2]) then	-- if player lap is faster than stored lap
			if akmPrintRecords.value then print("[AKM] "..p.name.." set a new #1 record!") end
			setAnnouncement("GOTITA", p.name.." just set a", "1st place record!", 8*TICRATE)
			S_StartSound(nil, sfx_cdpcm2, displayplayers[0])
			if p.name ~= savedTimes[1][3] then	-- if player is not same as stored lap, move stored lap down and set new lap as 1st record
				savedTimes[2] = savedTimes[1]
				savedTimes[2][1] = $ + 1
			end
			savedTimes[1] = {1, p.bestLap, p.name, p}
		elseif p.name ~= savedTimes[1][3] 
			setAnnouncement("GOTITB", p.name.." just set a", "2nd place record!", 8*TICRATE)
			if akmPrintRecords.value then print("[AKM] "..p.name.." set a new #2 record!") end
			savedTimes[2] = {2, p.bestLap, p.name, p}
		end
	elseif #savedTimes == 2 then
		if p.bestLap < tonumber(savedTimes[1][2]) then
			setAnnouncement("GOTITA", p.name.." just set a", "1st place record!", 8*TICRATE)
			S_StartSound(nil, sfx_cdpcm2, displayplayers[0])
			if akmPrintRecords.value then print("[AKM] "..p.name.." set a new #1 record!") end
			if p.name == savedTimes[1][3] then
				savedTimes[1] = {1, p.bestLap, p.name, p}
			else
				if p.name == savedTimes[2][3] then
					savedTimes[2] = savedTimes[1]
					savedTimes[2][1] = $ + 1
					savedTimes[1] = {1, p.bestLap, p.name, p}
				else
					savedTimes[3] = savedTimes[2]
					savedTimes[2] = savedTimes[1]
					savedTimes[3][1] = $ + 1
					savedTimes[2][1] = $ + 1
					savedTimes[1] = {1, p.bestLap, p.name, p}
				end
			end
		elseif p.bestLap < tonumber(savedTimes[2][2]) then --or p.bestLap == tonumber(savedTimes[1][2]) then 
			if akmPrintRecords.value then print("[AKM] "..p.name.." set a new #2 record!") end
			setAnnouncement("GOTITB", p.name.." just set a", "2nd place record!", 8*TICRATE)
			if p.name == savedTimes[2][3] then
				savedTimes[2] = {2, p.bestLap, p.name, p}
			else				
				savedTimes[3] = savedTimes[2]
				savedTimes[3][1] = $ + 1
				savedTimes[2] = {2, p.bestLap, p.name, p}
			end
		else
			 -- if not actually a new record or tied
			if p.name ~= savedTimes[2][3] then --or (p.bestLap == tonumber(savedTimes[2][2]) and p.name ~= savedTimes[2][3])
				if akmPrintRecords.value then print("[AKM] "..p.name.." set a new #3 record!") end
				setAnnouncement("GOTITC", p.name.." just set a", "3rd place record!", 8*TICRATE)
				savedTimes[3] = {3, p.bestLap, p.name, p}
			end
		end
	else
		for i, val in pairs(savedTimes)
			if not timeSet and p.bestLap < tonumber(val[2]) then
				-- new best time, replace it
				if akmPrintRecords.value then print("[AKM] "..p.name.." set a new #"..i.." record!") end
				
				-- check which index we're at and move other times down
				if i == 1 then
					setAnnouncement("GOTITA", p.name.." just set a", "1st place record!", 8*TICRATE)
					S_StartSound(nil, sfx_cdpcm2, displayplayers[0])
					if p.name == savedTimes[1][3] then
						savedTimes[1] = {i, p.bestLap, p.name, p}
					elseif p.name == savedTimes[2][3] then
						savedTimes[2] = savedTimes[1]
						savedTimes[2][1] = $ + 1
						savedTimes[1] = {i, p.bestLap, p.name, p}
					else
						savedTimes[3] = savedTimes[2]
						savedTimes[2] = savedTimes[1]
						savedTimes[2][1] = $ + 1
						savedTimes[3][1] = $ + 1
						savedTimes[1] = {i, p.bestLap, p.name, p}
					end
					timeSet = true
				elseif i == 2
					setAnnouncement("GOTITB", p.name.." just set a", "2nd place record!", 8*TICRATE)
					if p.name == savedTimes[2][3] then
						savedTimes[2] = {i, p.bestLap, p.name, p}
					else
						--if p.name == savedTimes[3] then
						savedTimes[3] = savedTimes[2]
						savedTimes[3][1] = $ + 1
						savedTimes[2] = {i, p.bestLap, p.name, p}
					end
					timeSet = true
				elseif i == 3
					if p.name ~= savedTimes[2][3] then	-- not actually a new record
						setAnnouncement("GOTITC", p.name.." just set a", "3rd place record!", 8*TICRATE)
						savedTimes[3] = {i, p.bestLap, p.name, p}
					end
					timeSet = true
				end
			end
		end
	end
end

addHook("PlayerCmd", function(p, cmd)
	if p.valid and not p.spectator and p.countdown ~= nil and p.countdown ~= 0 then
		cmd.forwardmove = 0
		--cmd.buttons = $ & ~BT_ACCELERATE
	elseif p.valid and not p.spectator and p.finished then
		cmd.forwardmove = 0
		cmd.buttons = $ & ~BT_ACCELERATE
	end
	
		for p in players.iterate
			if p.valid and not p.spectator then
				continue
			end
		end
end)

local function handlePlayer()
	for p in players.iterate
		// retry lap logic
		if raceActive and p.cmd.buttons & BT_CUSTOM1 and p.playerstate == PST_LIVE and p.countdown == 0 then
			if p.resetTimer == 0
				resetPlayer(p)
			else
				p.resetTimer = $ - 1
				p.resetWidth = $ + 4
			end
		elseif p.resetTimer ~= 10 and not p.finished and p.kartstuff[k_respawn] ~= 0 then p.resetTimer = 10	-- allows playerrs to quickly restart while respawning
		elseif p.resetTimer ~= 20 and not p.finished and p.kartstuff[k_respawn] == 0 then p.resetTimer = 20
		elseif p.resetTimer == 20 then p.resetWidth = 0
		end

		// check if the player just respawned
		if p.valid and not p.spectator and p.countdown ~= nil and p.countdown ~= 0 then
			if fallingStart and p.mo.momz/FRACUNIT ~= 0 then
				p.countdown = 59
				if p.respawnflash ~= 0 then p.respawnflash = $ - 1 end
				return
			end
			// when countdown hits 0 they can start racing
			if raceActive and p.countdown == 52 then
				S_StartSound(nil, sfx_lapsta, p)
			end
			p.countdown = $ - 1
			if p.countdown == 0 then
				if p.cmd.buttons & BT_ACCELERATE then 
					p.kartstuff[k_boostcharge] = 35 
				end
			end
			if p.respawnflash ~= 0 then p.respawnflash = $ - 1 end
		end
		
		// check if the player just joined
		if p.valid and not p.spectator and p.waitToJoin == 1 then
			if p.kartstuff[k_respawn] <= 1 then
				resetPlayer(p)
				p.waitToJoin = 0
			end
		end
		
		// check if players got any other item than sneakers
		if p.kartstuff[k_itemtype] ~= 0 and p.kartstuff[k_itemtype] ~= 1 then
			-- strip items
			K_StripItems(p)
		end

		// if player went into lap 2 we consider them finished
		if raceActive and not sprintMap and p.laps == 1 and not p.finished then
			// take away control from the player
			p.finished = true
			p.kartstuff[k_lapanimation] = 0
			
			// check if this was their best lap time
			--print("Lap time: "..p.lapTime.." ("..ticToTime(p.lapTime)..") by "..p.name)
			if p.bestLap == 0 or p.lapTime < p.bestLap
				p.bestLap = p.lapTime
				p.bestCPs = p.CPs
				insertBestLap(p)
				
				if akmPrintCPs.value then
					print("New record: "..ticToTime(p.bestLap).." by "..p.name)
					print("--------------------")
					print("Best checkpoints for time "..ticToTime(p.bestLap))
					for i, val in pairs(p.CPs)
						CONS_Printf(p, i..". "..ticToTime(p.CPs[i]))
					end
				end
			end
			
			// allow instant restart
			p.resetTimer = 1

		elseif raceActive and sprintMap and p.laps == 1 then
			// check if the player finished
			p.klaps = $ + 1
			p.laps = 0
			p.kartstuff[k_lapanimation] = 0
			
			if p.klaps == mapheaderinfo[gamemap].numlaps then
				//-- take away control from the player
				p.finished = true
				p.kartstuff[k_lapanimation] = 0
				p.laps = 0
				
				// check if this was their best lap time
				if p.bestLap == 0 or p.lapTime < p.bestLap
					p.bestLap = p.lapTime
					insertBestLap(p)
					
					if akmPrintCPs.value then
						print("New record: "..ticToTime(p.bestLap).." by "..p.name)
						print("--------------------")
						print("Best checkpoints for time "..ticToTime(p.bestLap))
						for i, val in pairs(p.CPs)
							CONS_Printf(p, i..". "..ticToTime(p.CPs[i]))
						end
					end
					
					// allow instant restart
					p.resetTimer = 1
				end
			end
		end
		
		if p.spectator and p.pflags & PF_WANTSTOJOIN then
			-- let the player join
			akmPlayerJoin(p)
		end
	end
end

-- remember when burnetto said "its hudding time" and then he hudded all over the place
local function drawPlayerHUD(v, p, c)
	// get map stuff
	local mapTitle = mapheaderinfo[gamemap].lvlttl
    local zoneTitle = mapheaderinfo[gamemap].zonttl
	
	// set up HUD vars
	local flags = V_SNAPTOTOP|V_SNAPTOLEFT
	local drawFlags = V_SNAPTOTOP
	local winWidth = v.width()/v.dupx();
	local winHeight = v.height()/v.dupy();
	local q = "?"
	local oldSpeed = 0
	local accel = 0
	
	local hudTimeBG = v.cachePatch("HUDTIME")
	local hudTimeBoostBG = v.cachePatch("HUDTIMEBOOST")
	local hudSpeedBG = v.cachePatch("HUDSPD")
	local hudSpeedDistG = v.cachePatch("HUDSPDD")
	local hudSpeedTachG = v.cachePatch("HUDSPDT")
	local hudTimeLeft = v.cachePatch("HUDTL")
	local hudRoundTimeG = v.cachePatch("HUDRTG")
	local hudPBG = v.cachePatch("HUDPB")
	local hudCPBG = v.cachePatch("HUDCPBG")
	local hudReset = v.cachePatch("HUDRESET")
	
	local hudBoost = v.cachePatch("HUDBST"+tostring(boostAnimNum))
	
	// data
	local mapName = mapTitle..(zoneTitle and " "..zoneTitle or "")
	local roundTimeString = ticToTime(roundTime)
	local splitTimeString = ticToTime(p.splittime)
	
	if colInterval == 24 then
		if infColor == V_REDMAP then infColor = 0
		else infColor = V_REDMAP end
		colInterval = 0
	else
		colInterval = $ + 1
	end
	
	// reset help
	if leveltime < (5*TICRATE + (3*TICRATE/4)) then
		local text = "HOLD CUSTOM1 TO RESET"
		v.drawString(160, (winHeight - 194), "HOLD CUSTOM1", V_SNAPTOTOP|infColor, "center")
		v.drawString(160, (winHeight - 184), "TO RESET", V_SNAPTOTOP|infColor, "center")
	elseif p.finished and raceActive then
		v.drawString(160, (winHeight - 44), "PRESS CUSTOM1", V_SNAPTOTOP|infColor, "center")
		v.drawString(160, (winHeight - 34), "TO RESET", V_SNAPTOTOP|infColor, "center")
	end
	
	// lap start indicator
	local K_CNT1 = v.cachePatch("K_CNT1A")
	local K_CNT2 = v.cachePatch("K_CNT2B")
	local K_CNT3 = v.cachePatch("K_CNT3A")
	local K_FIN = v.cachePatch("K_FINA")
	local K_ISSHOE = v.cachePatch("K_ISSHOE")
	
	local warnColor = 0
	if warnTime ~= 0 then
		if warnTime % 4 == 0 then
			warnColor = V_REDMAP
		else
			warnColor = 0
		end
	end
	
	local pColor
	if not p.spectator then pColor = v.getColormap(p.mo.skin, p.mo.color)
	else pColor = v.getColormap("sonic", 11)
	end
	
	-- round time left
	v.drawScaled(0, 68*FRACUNIT, FRACUNIT, hudTimeLeft, flags|V_60TRANS, pColor)
	v.drawScaled(64*FRACUNIT, 68*FRACUNIT, FRACUNIT, hudRoundTimeG, flags|V_10TRANS)
	v.drawString(4, 71, roundTimeString, flags|warnColor, "left")
	
	-- player best lap
	v.drawScaled(0, 52*FRACUNIT, FRACUNIT, hudTimeLeft, flags|V_60TRANS, pColor)
	v.drawScaled(64*FRACUNIT, 54*FRACUNIT, FRACUNIT, hudPBG, flags|V_20TRANS)
	v.drawString(4, 55, ticToTime(p.bestLap), flags, "left")
	
	// stop drawing here for spectator
	if p.valid and p.spectator then return end
	
	-- player lap time	
	v.drawScaled(125*FRACUNIT, 178*FRACUNIT, FRACUNIT, hudTimeBG, V_SNAPTOBOTTOM|V_60TRANS, pColor)
	v.drawString(160, (winHeight - 14), ticToTime(p.lapTime), V_SNAPTOTOP, "center")
	if (leveltime < starttime or p.countdown ~= 0) and p.cmd.buttons & BT_ACCELERATE and leveltime > introtime then
		v.drawScaled(114*FRACUNIT, 152*FRACUNIT, FRACUNIT, hudBoost, V_SNAPTOBOTTOM|V_10TRANS, pColor)
		if boostAnimNum ~= 15 then boostAnimNum = $ + 1 
		elseif boostAnimNum == 15 then boostAnimNum = 13 end
	else
		boostAnimNum = 1
	end
	
	if p.countdown ~= 0 and leveltime > 3 then 
		if p.countdown <= 17 then
			v.drawScaled(winWidth/2*FRACUNIT - K_CNT1.width/2*FRACUNIT, winHeight/2*FRACUNIT - K_CNT1.height/2*FRACUNIT, FRACUNIT, K_CNT1, flags)
		elseif p.countdown <= 35 then
			v.drawScaled(winWidth/2*FRACUNIT - K_CNT2.width/2*FRACUNIT, winHeight/2*FRACUNIT - K_CNT2.height/2*FRACUNIT, FRACUNIT, K_CNT2, flags)
		elseif p.countdown <= 52 then
			v.drawScaled(winWidth/2*FRACUNIT - K_CNT3.width/2*FRACUNIT, winHeight/2*FRACUNIT - K_CNT3.height/2*FRACUNIT, FRACUNIT, K_CNT3, flags)
		end
	end
	
	// reset timer
	if raceActive and not p.finished and p.cmd.buttons & BT_CUSTOM1 and p.countdown == 0 then
		v.drawFill(120, 37, 80 - p.resetWidth, 2, drawFlags|p.mo.color)
		v.drawFill(120, 53, 80 - p.resetWidth, 2, drawFlags|p.mo.color)
		v.draw(120, 40, hudReset, drawFlags, pColor)
		v.drawString(winWidth / 2, 42, "RESETTING", flags, "center")
	end
	
	// wait to join message
	if not p.finished and p.waitToJoin then
		v.drawString(winWidth / 2, winHeight / 2, "PLEASE WAIT...", flags, "center")
	end
	
	// speed and distance
	local speedHeightOffset = 0
	if CV_FindVar("showfps").value ~= 0 then speedHeightOffset = $ + 18 end
	if CV_FindVar("showping").value ~= 0 then speedHeightOffset = $ + 18 end
	v.drawScaled(234*FRACUNIT, 169*FRACUNIT - speedHeightOffset*FRACUNIT, FRACUNIT, hudSpeedBG, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_60TRANS, pColor)
	v.drawScaled((winWidth - 13)*FRACUNIT, winHeight*FRACUNIT - 24*FRACUNIT - speedHeightOffset*FRACUNIT, FRACUNIT, hudSpeedDistG, flags)
	v.drawScaled((winWidth - 13)*FRACUNIT, winHeight*FRACUNIT - 14*FRACUNIT - speedHeightOffset*FRACUNIT, FRACUNIT, hudSpeedTachG, flags)
	v.drawString(winWidth - 16, winHeight - 24 - speedHeightOffset, p.distance.." FU", flags, "right") 	// distance
	v.drawString(winWidth - 16, winHeight - 14 - speedHeightOffset, p.speed/FRACUNIT, flags, "right")	// speed

	// draw checkpoint time when hitting one
	if p.cpdisplay ~= 0 then
		if #p.bestCPs ~= 0 then
			local cpFillColor = nil
			local sign = nil
			if p.CPi then	-- if checkpoint improved
				cpFillColor = v.getColormap("sonic", SKINCOLOR_LIME)
				sign = "- "
			else
				cpFillColor = v.getColormap("sonic", SKINCOLOR_RASPBERRY)
				sign = "+ "
			end
		
			v.drawScaled(129*FRACUNIT, 72*FRACUNIT, FRACUNIT, hudCPBG, V_SNAPTOTOP|V_60TRANS, cpFillColor)
			v.drawString(154, 74, sign..ticToTime(p.cpsplit), V_SNAPTOTOP, "center") 
		end
		
		v.drawScaled(129*FRACUNIT, 60*FRACUNIT, FRACUNIT, hudCPBG, V_SNAPTOTOP|V_60TRANS, v.getColormap("sonic", SKINCOLOR_GREY))
		v.drawString(winWidth / 2, 62, splitTimeString, flags, "center")
	end
end
hud.add(drawPlayerHUD, game)

local function drawLeaderboards(v, player, c)
	
	// set up HUD vars
	local drawFlags = V_SNAPTOTOP|V_SNAPTOLEFT
	local textFlags = V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE
	local winWidth = v.width()/v.dupx();
	local winHeight = v.height()/v.dupy();
	
	local i = 0
	local maxScores = 8
	if winHeight >= 240 then maxScores = 10
	elseif winHeight >= 216 then maxScores = 8
	elseif winHeight >= 210 then maxScores = 7
	elseif winHeight >= 200 then maxScores = 6
	end
	
	// if saved times is not empty
	if #savedTimes ~= 0 then
		local drawFlags = V_SNAPTOTOP|V_SNAPTORIGHT
		local textFlags = V_SNAPTOTOP|V_SNAPTORIGHT|V_ALLOWLOWERCASE
		local bgSavedTime = v.cachePatch("HUDSAVEDTIME")
		local medalG = v.cachePatch("HUDMG")
		local medalS = v.cachePatch("HUDMS")
		local medalB = v.cachePatch("HUDMB")
		local i = 0
		for _, val in pairs(savedTimes)
		
			local highlight = 0
			if val[3] == player.name then highlight = V_GREENMAP 
			elseif player.spectator then highlight = V_GRAYMAP 
			end
			
			local pColor
			if not player.spectator then pColor = v.getColormap(player.mo.skin, player.mo.color)
			else pColor = v.getColormap("sonic", 11)
			end
			
			v.drawScaled(320*FRACUNIT-bgSavedTime.width*FRACUNIT, 4*FRACUNIT + i*FRACUNIT, FRACUNIT, bgSavedTime, drawFlags|V_60TRANS, pColor)
			if tonumber(val[1]) == 1 then v.drawScaled(250*FRACUNIT, 4*FRACUNIT + i*FRACUNIT, FRACUNIT, medalG, drawFlags, pColor)
			elseif tonumber(val[1]) == 2 then v.drawScaled(250*FRACUNIT, 4*FRACUNIT + i*FRACUNIT, FRACUNIT, medalS, drawFlags, pColor)
			elseif tonumber(val[1]) == 3 then v.drawScaled(250*FRACUNIT, 4*FRACUNIT + i*FRACUNIT, FRACUNIT, medalB, drawFlags, pColor)
			end
			
			--v.drawString(320 + i, 4, val[1], textFlags, "right")
			v.drawString(316, 7 + i, ticToTime(val[2]), textFlags|highlight, "small-right")
			v.drawString(316, 11 + i, val[3], textFlags|highlight, "small-right")
			i = i + 16
		end
	end
	
	for index, p in pairs(bestLaps)
		if akmHideLB.value ~= 0 and p.lapTime >= akmHideLB.value*TICRATE then return end
		// data
		local lapTime = ticToTime(p.bestLap)
		local highlight = 0
		if player == p and not p.spectator then
			highlight = V_GREENMAP
		elseif p.spectator then
			highlight = 0|V_50TRANS
		end
		
		// draw top 3 big
		if index <= 3 then
			// header
			if not p.spectator then
				local pFace = v.cachePatch(skins[p.mo.skin].facerank)
				v.drawScaled(20*FRACUNIT, ((84 + i))*FRACUNIT, FRACUNIT, pFace, drawFlags, v.getColormap(p.mo.skin, p.mo.color))
			end
			v.drawString(18 , ((85 + i)), index, textFlags|highlight, "right")
			v.drawString(38, ((85 + i)), p.name, textFlags|highlight, "small")
			v.drawString(38, ((91 + i)), lapTime, textFlags|highlight, "left")
			i = i + 18
		elseif index <= maxScores then // everyone else smol
			v.drawString(18 , ((85 + i)), index, textFlags|highlight, "right")
			v.drawString(20, ((85 + i)), p.name, textFlags|highlight, "small")
			v.drawString(20, ((91 + i)), lapTime, textFlags|highlight, "small")
			i = i + 12
		end
	end
end
hud.add(drawLeaderboards, game)

addHook("ThinkFrame", handleRace)
addHook("ThinkFrame", handlePlayer)
addHook("ThinkFrame", function()
	for p in players.iterate
		if p.maniaReady == nil
			setupPlayer(p)
			if akmDebug.value then CONS_Printf(p, "Now mania ready!") end
		end
	end
end)

addHook("PlayerQuit", function(p, r)
	-- remove this player's lap from scores
	for index, bP in pairs(bestLaps)
		if #bP == #p then
			table.remove(bestLaps, index)
		end
	end
	
	-- resort the table
	table.sort(bestLaps, function(a, b)
		return a.bestLap < b.bestLap
	end)
end)

-- announcements
local function drawAnnouncement(v, p, c)
	if announcementTime == 0 then return end
	
	// set up HUD vars
	local drawFlags = V_SNAPTOTOP|V_SNAPTOLEFT
	local textFlags = V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE
	local winWidth = v.width()/v.dupx();
	local winHeight = v.height()/v.dupy();
	
	local graphic = v.cachePatch(announcementGraphic)
	--local graphic = v.cachePatch("GOTITA")
	v.drawScaled(62*FRACUNIT - graphic.width/2*FRACUNIT, 10*FRACUNIT, FRACUNIT/2, graphic, drawFlags)
	if #announcementMessage == 1 then
		v.drawString(64, 10, announcementMessage[1], textFlags, "small")
	elseif #announcementMessage == 2 then
		v.drawString(64, 10, announcementMessage[1], textFlags, "small")
		v.drawString(64, 15, announcementMessage[2], textFlags, "small")
	end
	
end
hud.add(drawAnnouncement, game)

addHook("MobjCollide", playerColRet, MT_PLAYER)
addHook("MobjMoveCollide", playerColRet, MT_PLAYER)

addHook("NetVars", function(n)
	roundTime = n($)
	endTime = n($)
	raceActive = n($)
	worstScore = n($)
	bestLaps = n($)
	savedTimes = n($)
	allTimes = n($)
	
	spawnPointx = n($)
	spawnPointy = n($)
	spawnPointz = n($)
	spawnPointangle = n($)
	
	warnTime = n($)
	exitTime = n($)
	announcementTime = n($)
	announcementGraphic = n($)
	announcementMessage = n($)
end)

addHook("PlayerJoin", function(playernum)
	if playernum == 1 then
		-- just reset the map, make life easy
		-- probably fucks up listen hosts lol
		COM_BufInsertText(server, "restartlevel")
	end
end)

addHook("MobjThinker", function(mo)
	-- just fuggin kill floating items
	P_RemoveMobj(mo)
end, MT_FLOATINGITEM)

addHook("MobjThinker", function(mo)
	// respawn items quickly
	if mo.valid and mo.type == MT_RANDOMITEM then
		if mo.fuse ~= 0 then 
			mo.fuse = 0 
			mo.threshold = 0
			P_SpawnMobj(mo.x, mo.y, mo.z, MT_RANDOMITEM)
		end
	end
end)

// load saved records on server boot
if consoleplayer == server then
	print("[AKM] Reading saved times from disk")
	readMapTimes()
end

print("[AKM] Aqua's KartMania initialized! Have fun TA'ing :)")
print("[AKM] Loaded "..#allTimes.." records")